Getting Started with ListBox Web Component
Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.
Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.
Quick start
- Install the package:
npm install smart-webcomponents
- Load the ListBox module (ES module script):
<script type="module" src="node_modules/smart-webcomponents/source/modules/smart.listbox.js"></script>
- Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):
<link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />
- Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host
div(you mount programmatically with appendTo):
Semantic element (id matches the selector in Smart()):
<smart-list-box id="listbox"></smart-list-box>
Host container (id matches appendTo on Smart.ListBox):
<div id="listboxContainer"></div>
- Initialize after the module loads: define a const listboxOptions object, then either bind with Smart('#listbox', ...) on the semantic tag or use new Smart.ListBox({ ...listboxOptions, appendTo: '#listboxContainer' }) on the host
div:
<script type="module"> import 'node_modules/smart-webcomponents/source/modules/smart.listbox.js'; const listboxOptions = { selectionMode: "one" }; // Option A - semantic <smart-list-box> with id="listbox" Smart('#listbox', class { get properties() { return listboxOptions; } }); // Option B - host div id="listboxContainer" // const listboxInstance = new Smart.ListBox({ // ...listboxOptions, // appendTo: '#listboxContainer' // }); // Option C - constructor(selector, options), then append the returned element yourself // const myListBox = new Smart.ListBox('#listbox', listboxOptions); // document.body.appendChild(myListBox); </script>
Uncomment Option B when you use the host
div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.ListBox('#listbox', listboxOptions) with appendChild, and document.createElement('smart-list-box') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components). - Serve the folder over HTTP (or use your bundler dev server) and open the page.
Runtime cookbook
Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.ListBox({ ...options, appendTo: '#...' }); new Smart.ListBox('#listbox', listboxOptions) plus appendChild on the returned element; and document.createElement('smart-list-box') then assigning options via .props or Object.assign on the element.
Constructor with a selector string and options, then append the returned element (for example const myListBox = new Smart.ListBox('#listbox', listboxOptions)):
const listboxOptions = { selectionMode: "one" };
const myListBox = new Smart.ListBox('#listbox', listboxOptions);
document.body.appendChild(myListBox);
Create with document.createElement('smart-list-box'), assign properties (same as any custom element), then append:
const listboxOptions = { selectionMode: "one" };
const listbox = document.createElement('smart-list-box');
Object.assign(listbox, listboxOptions);
document.body.appendChild(listbox);
Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):
import "../../source/modules/smart.listbox.js";
document.readyState === 'complete' ? init() : window.addEventListener('load', init);
function init() {
const listboxOptions = { selectionMode: "one" };
const listbox = new Smart.ListBox({
...listboxOptions,
appendTo: '#listboxContainer'
});
}
Demo
Appearance
Smart.ListBox allows to completely customize the content of the list items.
In order to change the content of an item, itemTemplate property has to be applied by assigning the id of an HTML Template element that's located inside the DOM. Here's an example:
<!DOCTYPE html>
<html lang="en">
<head>
<link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
<script type="text/javascript" src="../../source/modules/smart.listbox.js"></script>
</head>
<body>
<template id="template">
<span class="glyphicon glyphicon-ok"></span>
<span>{{label}}</span>
</template>
<smart-list-box item-template="template">
<smart-list-item value="1">Item 1</smart-list-item>
<smart-list-item value="2">Item 2</smart-list-item>
<smart-list-item selected value="3">Item 3</smart-list-item>
</smart-list-box>
</body>
</html>
The template contains a binding field surrounded by curly braces {{ label }}. The text between the brackets can be random.
Demo
Data Binding
Adding data to the list box can be accomplished in a few ways:
-
Nesting jqxListItem elements inside the list box's body in the HTML:
<smart-list-box> <smart-list-item value="value1">Item1</smart-list-item> <smart-list-item selected value="value2">Item2</smart-list-item> <smart-list-item value="value3">Item3</smart-list-item> </smart-list-box>Demo
Smart.ListItem has a label and a value property. The value property can have a separate value from the label or no value at all. The user can prefer to apply a value only to the label and it will be automatically assigned to value as well.
The text inside the list item represents the value of the label property. It can also be set in the HTML code like shown in the example above.
-
Nesting Smart.ListItemGroup elements inside the list box's body in the HTML:
<smart-list-box> <smart-list-items-group label="Group 1"> <smart-list-item>Item 1</smart-list-item> <smart-list-item>Item 2</smart-list-item> <smart-list-item>Item 3</smart-list-item> </smart-list-items-group> <smart-list-items-group label="Group 2"> <smart-list-item>Item 4</smart-list-item> <smart-list-item>Item 5</smart-list-item> <smart-list-item>Item 6</smart-list-item> </smart-list-items-group> <smart-list-items-group label="Group 3"> <smart-list-item>Item 7</smart-list-item> <smart-list-item>Item 8</smart-list-item> <smart-list-item>Item 9</smart-list-item> </smart-list-items-group> </smart-list-box>Demo
Smart.ListItemGroup represents a group of items.
-
Nesting HTML list elements inside the list box's body in the HTML:
<smart-list-box> <ul label="Group 1"> <li>Item 1</li> <li>Item 2</li> <li>Item 3</li> <li>Item 4</li> <li>Item 5</li> </ul> <ul label="Group 2"> <li>Item 6</li> <li>Item 7</li> <li>Item 8</li> <li>Item 9</li> <li>Item 10</li> </ul> </smart-list-box>List items can be added without the ul tag. The grouping can be added at a later stage by setting the grouped property to the element.
Demo
-
Nesting optgroup elements inside the list box's body in the HTML:
<smart-list-box> <optgroup label="Group 1"> <option value="1">Item 1</option> <option value="2">Item 2</option> </optgroup> <optgroup label="Group 2"> <option value="3">Item 3</option> <option value="4">Item 4</option> </optgroup> </smart-list-box>optgroups are the items of an HTML select element. As usual the value attribute can be applied to each list item to assign a specific value that can differ from the label.
Demo
-
Setting the dataSource property of the element to a new value of type Array.
The property can be changed dynamically via javascript after the element has been initialized:
<!DOCTYPE html> <html> <head> <link rel="stylesheet" href="./../../source/styles/smart.default.css" type="text/css" /> <script type="text/javascript" src="../../source/modules/smart.listbox.js"></script> <script> window.onload = function () { document.querySelector('smart-list-box').dataSource = [ "Item 1", "Item 2", "Item 3" ]; } </script> </head> <body> <smart-list-box></smart-list-box> </body> </html>Demo
dataSource accepts Arrays of strings or Objects. An object can contain more specific data for the items. For example:
<!DOCTYPE html> <html> <head> <link rel="stylesheet" href="./../../source/styles/smart.default.css" type="text/css" /> <script type="text/javascript" src="../../source/modules/smart.listbox.js"></script> <script> window.onload = function () { var listBox = document.querySelector('smart-list-box'); listBox.dataSource = [ { label: 'Item 1', value: 1 }, { label: 'Item 2', value: 2 }, { label: 'Item 3', value: 3, disabled: true }, { label: 'Item 4', value: 4 }, { label: 'Item 5', value: 5 }, ]; } </script> </head> <body> <smart-list-box></smart-list-box> </body> </html>Demo
Like every other custom element property, dataSource can also be set from the HTML in the tag of the element, like so:
<smart-list-box data-source='["Item1", "Item2", "Item3"]'></smart-list-box>
Demo
Manipulating the content
The element offers the following methods:
-
Insert method can create and insert new list items into the element.
The insert method can be called at any time after the element has been initialized.
The method accepts two arguments:
- The index at which the item will be inserted.
- An array of strings or a single string representing the labels of the items to be inserted.
<!DOCTYPE html> <html> <head> <link rel="stylesheet" href="./../../source/styles/smart.default.css" type="text/css" /> <script type="text/javascript" src="../../source/modules/smart.listbox.js"></script> <script> window.onload = function () { var listBox = document.querySelector('smart-list-box'); listBox.insert(0, ["Item1", "Item2", "Item3"]); listBox.insert(2, 'Item4'); } </script> </head> <body> <smart-list-box></smart-list-box> </body> </html>Demo
-
Update method allow List items to be modified after creation.
Update method accepts two arguments:- The index of the item to be updated.
- Details for the item. This argument can be an object containing properties of Smart.ListItem, e.g. label, value, disabled. It can also be a simple string that represents the new label of the item that will be updated.
<!DOCTYPE html> <html> <head> <link rel="stylesheet" href="./../../source/styles/smart.default.css" type="text/css" /> <script type="text/javascript" src="../../source/modules/smart.listbox.js"></script> <script> window.onload = function () { var listBox = document.querySelector('smart-list-box'); //Create items listBox.insert(0, ["Item1", "Item2", "Item3"]); listBox.insert(2, 'Item4'); //Update items listBox.update(1, 'Item12'); listBox.update(2, { label: 'Item13', value: '13', disabled: true }); } </script> </head> <body> <smart-list-box></smart-list-box> </body> </html>Demo
-
Remove deletes an item from the element. The method accepts a single argument - the index of the item to be removed.
Here's an example:
<!DOCTYPE html> <html> <head> <link rel="stylesheet" href="./../../source/styles/smart.default.css" type="text/css" /> <script type="text/javascript" src="../../source/modules/smart.listbox.js"></script> <script> window.onload = function () { var listBox = document.querySelector('smart-list-box'); //Create items listBox.insert(0, ["Item1", "Item2", "Item3"]); listBox.insert(2, 'Item4'); //Update items listBox.update(1, 'Item12'); listBox.update(2, { label: 'Item13', value: '13', disabled: true }); //Remove items listBox.remove(2); listBox.remove(0); } </script> </head> <body> <smart-list-box></smart-list-box> </body> </html>Demo
-
clearItems removes all items from the element. Take no arguments:
window.onload = function () { var listBox = document.querySelector('smart-list-box'); listBox.clearItems(); }Demo
Behavior
jqxListBox has multiple selection modes that define it's behavior:
- none - item selection is disabled
- default - single selection that allows multiple items to be selected using the keyboard keys : "SHIFT" or "CTRL".
- zeroOrMany - multiple item selection that allows empty selection.
- oneOrMany - multiple item selection that allows at least one item to be selected.
- zeroOrOne - single item selection that allows empty selection as well.
- one - single item selection. Doesn't allow empty selection. One item must always be selected.
- checkBox - multiple item selection using check boxes. Allows empty selection.
- radioButton - single item selection using radio buttons. If grouping is enabled the selection mode allows one selected item per group
Selection mode can be changed using javascript like so:
<!DOCTYPE html>
<html>
<head>
<link rel="stylesheet" href="./../../source/styles/smart.default.css" type="text/css" />
<script type="text/javascript" src="../../source/modules/smart.listbox.js"></script>
<script>
window.onload = function () {
var listBox = document.querySelector('smart-list-box');
listBox.selectionMode = 'checkBox';
}
</script>
</head>
<body>
<smart-list-box>
<smart-list-item>Item 1</smart-list-item>
<smart-list-item>Item 2</smart-list-item>
<smart-list-item>Item 3</smart-list-item>
</smart-list-box>
</body>
</html>
Demo
Keyboard Support
The following keys apply to the dropDownList popup when it's opened:
| Key | Action |
|---|---|
| Arrow Up / Arrow Left | Navigate to the previous item. |
| Arrow Down / Arrow Right | Navigate to the next item. |
| Home | Navigate to the first item. |
| End | Navigate to the last item. |
| Page Up | Navigate to the first item in the next page. |
| Page Down | Navigate to the last item of the previous page. |
| Space / Enter | Selects / Deselects an item. |
Append to the DOM:
const container = document.getElementById('listbox-container');
container.appendChild(listbox);
Remove from the DOM:
listbox.remove();
Set a property:
listbox.disabled = true; listbox.theme = 'dark';
Get a property value:
const isDisabled = listbox.disabled; const currentTheme = listbox.theme;
Invoke a method:
listbox.refresh(); listbox.focus();
Add event listener:
listbox.addEventListener('change', (event) => {
console.log('change triggered:', event.detail.addedItems);
});
Remove event listener:
const handleListBoxEvent = (event) => {
console.log('change triggered:', event.detail.addedItems);
};
listbox.addEventListener('change', handleListBoxEvent);
listbox.removeEventListener('change', handleListBoxEvent);
Accessibility
The ListBox component follows WAI-ARIA best practices:
- Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
- ARIA roles - Appropriate roles and labels are applied automatically
- Focus management - Visible focus indicators for keyboard users
- Screen readers - State changes are announced to assistive technology
- High contrast - Supports Windows High Contrast Mode and forced colors
For custom labeling, set aria-label or aria-labelledby attributes on the component.
Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React ListBox Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/listbox/basic/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React from "react";
import { ListBox, ListItem, ListItemsGroup } from 'smart-webcomponents-react/listbox';

function App() {
	return (
		<div>
			<ListBox selectedIndexes={[0]}>
				<ListItem value="1">Affogato</ListItem>
				<ListItem value="2">Americano</ListItem>
				<ListItem value="3">Bicerin</ListItem>
				<ListItem value="4">Breve</ListItem>
				<ListItem value="5">Cappuccino</ListItem>
				<ListItem value="6">Cafe Crema</ListItem>
				<ListItem value="7">Cafe Corretto</ListItem>
				<ListItem value="8">Cafe macchiato</ListItem>
				<ListItem value="9">Cafe mocha</ListItem>
				<ListItem value="10">Cortado</ListItem>
				<ListItem value="11">Cuban espresso</ListItem>
				<ListItem value="12">Espresso</ListItem>
				<ListItem value="13">Eiskaffee</ListItem>
				<ListItem value="14">Frappuccino</ListItem>
				<ListItem value="15">Galao</ListItem>
				<ListItem value="16">Greek frappe coffee</ListItem>
				<ListItem value="17">Iced Coffee</ListItem>
				<ListItem value="18">Instant Coffee</ListItem>
				<ListItem value="19">Latte</ListItem>
				<ListItem value="20">Liqueur coffee</ListItem>
			</ListBox>
		</div>
	);
}

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { ListBox, ListBoxProps } from 'smart-webcomponents-react/listbox';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The ListBox component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular ListBox - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/listbox/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import ListBoxModule from smart-webcomponents-angular/listbox: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { ListBoxModule } from 'smart-webcomponents-angular/listbox';

4 Root component (standalone)

Add ListBoxModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { ListBoxComponent } from 'smart-webcomponents-angular/listbox';

import { ListBoxModule } from 'smart-webcomponents-angular/listbox';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ ListBoxModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	@ViewChild('listbox', { read: ListBoxComponent, static: false }) listbox!: ListBoxComponent;
	
 
	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.
	    
    // no code

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-list-box as needed:

 <smart-list-box #listbox [selectionMode]="'zeroOrOne'">
    <smart-list-item [value]="'Afghanistan'">Afghanistan</smart-list-item>
    <smart-list-item [selected]="true" [value]="'Albania'">Albania</smart-list-item>
    <smart-list-item [value]="'Algeria'">Algeria</smart-list-item>
    <smart-list-item [value]="'American Samoa'">American Samoa</smart-list-item>
    <smart-list-item [value]="'Andorra'">Andorra</smart-list-item>
    <smart-list-item [value]="'Angola'">Angola</smart-list-item>
    <smart-list-item [value]="'Anguilla'">Anguilla</smart-list-item>
    <smart-list-item [value]="'Antarctica'">Antarctica</smart-list-item>
    <smart-list-item [value]="'Antigua and Barbuda'">Antigua and Barbuda</smart-list-item>
    <smart-list-item [value]="'Argentina'">Argentina</smart-list-item>
    <smart-list-item [value]="'Armenia'">Armenia</smart-list-item>
    <smart-list-item [value]="'Aruba'">Aruba</smart-list-item>
    <smart-list-item [value]="'Australia'">Australia</smart-list-item>
    <smart-list-item [value]="'Austria'">Austria</smart-list-item>
    <smart-list-item [value]="'Azerbaijan'">Azerbaijan</smart-list-item>
    <smart-list-item [value]="'Bahamas'">Bahamas</smart-list-item>
    <smart-list-item [value]="'Bahrain'">Bahrain</smart-list-item>
    <smart-list-item [value]="'Bangladesh'">Bangladesh</smart-list-item>
    <smart-list-item [value]="'Barbados'">Barbados</smart-list-item>
    <smart-list-item [value]="'Belarus'">Belarus</smart-list-item>
    <smart-list-item [value]="'Belgium'">Belgium</smart-list-item>
    <smart-list-item [value]="'Belize'">Belize</smart-list-item>
    <smart-list-item [value]="'Benin'">Benin</smart-list-item>
    <smart-list-item [value]="'Bermuda'">Bermuda</smart-list-item>
    <smart-list-item [value]="'Bhutan'">Bhutan</smart-list-item>
    <smart-list-item [value]="'Bolivia'">Bolivia</smart-list-item>
    <smart-list-item [value]="'Bosnia and Herzegovina'">Bosnia and Herzegovina</smart-list-item>
    <smart-list-item [value]="'Botswana'">Botswana</smart-list-item>
    <smart-list-item [value]="'Bouvet Island'">Bouvet Island</smart-list-item>
    <smart-list-item [value]="'Brazil'">Brazil</smart-list-item>
    <smart-list-item [value]="'British Indian Ocean Territory'">British Indian Ocean Territory</smart-list-item>
    <smart-list-item [value]="'Brunei Darussalam'">Brunei Darussalam</smart-list-item>
    <smart-list-item [value]="'Bulgaria'">Bulgaria</smart-list-item>
    <smart-list-item [value]="'Burkina Faso'">Burkina Faso</smart-list-item>
    <smart-list-item [value]="'Burundi'">Burundi</smart-list-item>
    <smart-list-item [value]="'Cambodia'">Cambodia</smart-list-item>
    <smart-list-item [value]="'Cameroon'">Cameroon</smart-list-item>
    <smart-list-item [value]="'Canada'">Canada</smart-list-item>
    <smart-list-item [value]="'Cape Verde'">Cape Verde</smart-list-item>
    <smart-list-item [value]="'Cayman Islands'">Cayman Islands</smart-list-item>
    <smart-list-item [value]="'Central African Republic'">Central African Republic</smart-list-item>
    <smart-list-item [value]="'Chad'">Chad</smart-list-item>
    <smart-list-item [value]="'Chile'">Chile</smart-list-item>
    <smart-list-item [value]="'China'">China</smart-list-item>
    <smart-list-item [value]="'Christmas Island'">Christmas Island</smart-list-item>
    <smart-list-item [value]="'Cocos (Keeling) Islands'">Cocos Islands</smart-list-item>
    <smart-list-item [value]="'Colombia'">Colombia</smart-list-item>
    <smart-list-item [value]="'Comoros'">Comoros</smart-list-item>
    <smart-list-item [value]="'Congo'">Congo</smart-list-item>
    <smart-list-item [value]="'Congo, The Democratic Republic of The'">Congo</smart-list-item>
    <smart-list-item [value]="'Cook Islands'">Cook Islands</smart-list-item>
    <smart-list-item [value]="'Costa Rica'">Costa Rica</smart-list-item>
    <smart-list-item [value]="'Cote D\'ivoire'">Cote D'ivoire</smart-list-item>
    <smart-list-item [value]="'Croatia'">Croatia</smart-list-item>
    <smart-list-item [value]="'Cuba'">Cuba</smart-list-item>
    <smart-list-item [value]="'Cyprus'">Cyprus</smart-list-item>
    <smart-list-item [value]="'Czech Republic'">Czech Republic</smart-list-item>
    <smart-list-item [value]="'Denmark'">Denmark</smart-list-item>
    <smart-list-item [value]="'Djibouti'">Djibouti</smart-list-item>
    <smart-list-item [value]="'Dominica'">Dominica</smart-list-item>
    <smart-list-item [value]="'Dominican Republic'">Dominican Republic</smart-list-item>
    <smart-list-item [value]="'Ecuador'">Ecuador</smart-list-item>
    <smart-list-item [value]="'Egypt'">Egypt</smart-list-item>
    <smart-list-item [value]="'El Salvador'">El Salvador</smart-list-item>
    <smart-list-item [value]="'Equatorial Guinea'">Equatorial Guinea</smart-list-item>
    <smart-list-item [value]="'Eritrea'">Eritrea</smart-list-item>
    <smart-list-item [value]="'Estonia'">Estonia</smart-list-item>
    <smart-list-item [value]="'Ethiopia'">Ethiopia</smart-list-item>
    <smart-list-item [value]="'Falkland Islands (Malvinas)'">Falkland Islands</smart-list-item>
    <smart-list-item [value]="'Faroe Islands'">Faroe Islands</smart-list-item>
    <smart-list-item [value]="'Fiji'">Fiji</smart-list-item>
    <smart-list-item [value]="'Finland'">Finland</smart-list-item>
    <smart-list-item [value]="'France'">France</smart-list-item>
    <smart-list-item [value]="'French Guiana'">French Guiana</smart-list-item>
    <smart-list-item [value]="'French Polynesia'">French Polynesia</smart-list-item>
    <smart-list-item [value]="'French Southern Territories'">French Southern Territories</smart-list-item>
    <smart-list-item [value]="'Gabon'">Gabon</smart-list-item>
    <smart-list-item [value]="'Gambia'">Gambia</smart-list-item>
    <smart-list-item [value]="'Georgia'">Georgia</smart-list-item>
    <smart-list-item [value]="'Germany'">Germany</smart-list-item>
    <smart-list-item [value]="'Ghana'">Ghana</smart-list-item>
    <smart-list-item [value]="'Gibraltar'">Gibraltar</smart-list-item>
    <smart-list-item [value]="'Greece'">Greece</smart-list-item>
    <smart-list-item [value]="'Greenland'">Greenland</smart-list-item>
    <smart-list-item [value]="'Grenada'">Grenada</smart-list-item>
    <smart-list-item [value]="'Guadeloupe'">Guadeloupe</smart-list-item>
    <smart-list-item [value]="'Guam'">Guam</smart-list-item>
    <smart-list-item [value]="'Guatemala'">Guatemala</smart-list-item>
    <smart-list-item [value]="'Guinea'">Guinea</smart-list-item>
    <smart-list-item [value]="'Guinea-bissau'">Guinea-bissau</smart-list-item>
    <smart-list-item [value]="'Guyana'">Guyana</smart-list-item>
    <smart-list-item [value]="'Haiti'">Haiti</smart-list-item>
    <smart-list-item [value]="'Heard Island and Mcdonald Islands'">Heard Island and Mcdonald Islands</smart-list-item>
    <smart-list-item [value]="'Holy See (Vatican City State)'">Holy See</smart-list-item>
    <smart-list-item [value]="'Honduras'">Honduras</smart-list-item>
    <smart-list-item [value]="'Hong Kong'">Hong Kong</smart-list-item>
    <smart-list-item [value]="'Hungary'">Hungary</smart-list-item>
    <smart-list-item [value]="'Iceland'">Iceland</smart-list-item>
    <smart-list-item [value]="'India'">India</smart-list-item>
    <smart-list-item [value]="'Indonesia'">Indonesia</smart-list-item>
    <smart-list-item [value]="'Iran, Islamic Republic of'">Iran</smart-list-item>
    <smart-list-item [value]="'Iraq'">Iraq</smart-list-item>
    <smart-list-item [value]="'Ireland'">Ireland</smart-list-item>
    <smart-list-item [value]="'Israel'">Israel</smart-list-item>
    <smart-list-item [value]="'Italy'">Italy</smart-list-item>
    <smart-list-item [value]="'Jamaica'">Jamaica</smart-list-item>
    <smart-list-item [value]="'Japan'">Japan</smart-list-item>
    <smart-list-item [value]="'Jordan'">Jordan</smart-list-item>
    <smart-list-item [value]="'Kazakhstan'">Kazakhstan</smart-list-item>
    <smart-list-item [value]="'Kenya'">Kenya</smart-list-item>
    <smart-list-item [value]="'Kiribati'">Kiribati</smart-list-item>
    <smart-list-item [value]="'Korea, Democratic People\'s Republic of'">Korea</smart-list-item>
    <smart-list-item [value]="'Korea, Republic of'">Korea, Republic of</smart-list-item>
    <smart-list-item [value]="'Kuwait'">Kuwait</smart-list-item>
    <smart-list-item [value]="'Kyrgyzstan'">Kyrgyzstan</smart-list-item>
    <smart-list-item [value]="'Lao People\'s Democratic Republic'">Lao People's Democratic Republic</smart-list-item>
    <smart-list-item [value]="'Latvia'">Latvia</smart-list-item>
    <smart-list-item [value]="'Lebanon'">Lebanon</smart-list-item>
    <smart-list-item [value]="'Lesotho'">Lesotho</smart-list-item>
    <smart-list-item [value]="'Liberia'">Liberia</smart-list-item>
    <smart-list-item [value]="'Libyan Arab Jamahiriya'">Libyan Arab Jamahiriya</smart-list-item>
    <smart-list-item [value]="'Liechtenstein'">Liechtenstein</smart-list-item>
    <smart-list-item [value]="'Lithuania'">Lithuania</smart-list-item>
    <smart-list-item [value]="'Luxembourg'">Luxembourg</smart-list-item>
    <smart-list-item [value]="'Macao'">Macao</smart-list-item>
    <smart-list-item [value]="'Macedonia, The Former Yugoslav Republic of'">Macedonia</smart-list-item>
    <smart-list-item [value]="'Madagascar'">Madagascar</smart-list-item>
    <smart-list-item [value]="'Malawi'">Malawi</smart-list-item>
    <smart-list-item [value]="'Malaysia'">Malaysia</smart-list-item>
    <smart-list-item [value]="'Maldives'">Maldives</smart-list-item>
    <smart-list-item [value]="'Mali'">Mali</smart-list-item>
    <smart-list-item [value]="'Malta'">Malta</smart-list-item>
    <smart-list-item [value]="'Marshall Islands'">Marshall Islands</smart-list-item>
    <smart-list-item [value]="'Martinique'">Martinique</smart-list-item>
    <smart-list-item [value]="'Mauritania'">Mauritania</smart-list-item>
    <smart-list-item [value]="'Mauritius'">Mauritius</smart-list-item>
    <smart-list-item [value]="'Mayotte'">Mayotte</smart-list-item>
    <smart-list-item [value]="'Mexico'">Mexico</smart-list-item>
    <smart-list-item [value]="'Micronesia, Federated States of'">Micronesia</smart-list-item>
    <smart-list-item [value]="'Moldova, Republic of'">Moldova, Republic of</smart-list-item>
    <smart-list-item [value]="'Monaco'">Monaco</smart-list-item>
    <smart-list-item [value]="'Mongolia'">Mongolia</smart-list-item>
    <smart-list-item [value]="'Montserrat'">Montserrat</smart-list-item>
    <smart-list-item [value]="'Morocco'">Morocco</smart-list-item>
    <smart-list-item [value]="'Mozambique'">Mozambique</smart-list-item>
    <smart-list-item [value]="'Myanmar'">Myanmar</smart-list-item>
    <smart-list-item [value]="'Namibia'">Namibia</smart-list-item>
    <smart-list-item [value]="'Nauru'">Nauru</smart-list-item>
    <smart-list-item [value]="'Nepal'">Nepal</smart-list-item>
    <smart-list-item [value]="'Netherlands'">Netherlands</smart-list-item>
    <smart-list-item [value]="'Netherlands Antilles'">Netherlands Antilles</smart-list-item>
    <smart-list-item [value]="'New Caledonia'">New Caledonia</smart-list-item>
    <smart-list-item [value]="'New Zealand'">New Zealand</smart-list-item>
    <smart-list-item [value]="'Nicaragua'">Nicaragua</smart-list-item>
    <smart-list-item [value]="'Niger'">Niger</smart-list-item>
    <smart-list-item [value]="'Nigeria'">Nigeria</smart-list-item>
    <smart-list-item [value]="'Niue'">Niue</smart-list-item>
    <smart-list-item [value]="'Norfolk Island'">Norfolk Island</smart-list-item>
    <smart-list-item [value]="'Northern Mariana Islands'">Northern Mariana Islands</smart-list-item>
    <smart-list-item [value]="'Norway'">Norway</smart-list-item>
    <smart-list-item [value]="'Oman'">Oman</smart-list-item>
    <smart-list-item [value]="'Pakistan'">Pakistan</smart-list-item>
    <smart-list-item [value]="'Palau'">Palau</smart-list-item>
    <smart-list-item [value]="'Palestinian Territory, Occupied'">Palestinian Territory, Occupied</smart-list-item>
    <smart-list-item [value]="'Panama'">Panama</smart-list-item>
    <smart-list-item [value]="'Papua New Guinea'">Papua New Guinea</smart-list-item>
    <smart-list-item [value]="'Paraguay'">Paraguay</smart-list-item>
    <smart-list-item [value]="'Peru'">Peru</smart-list-item>
    <smart-list-item [value]="'Philippines'">Philippines</smart-list-item>
    <smart-list-item [value]="'Pitcairn'">Pitcairn</smart-list-item>
    <smart-list-item [value]="'Poland'">Poland</smart-list-item>
    <smart-list-item [value]="'Portugal'">Portugal</smart-list-item>
    <smart-list-item [value]="'Puerto Rico'">Puerto Rico</smart-list-item>
    <smart-list-item [value]="'Qatar'">Qatar</smart-list-item>
    <smart-list-item [value]="'Reunion'">Reunion</smart-list-item>
    <smart-list-item [value]="'Romania'">Romania</smart-list-item>
    <smart-list-item [value]="'Russian Federation'">Russian Federation</smart-list-item>
    <smart-list-item [value]="'Rwanda'">Rwanda</smart-list-item>
    <smart-list-item [value]="'Saint Helena'">Saint Helena</smart-list-item>
    <smart-list-item [value]="'Saint Kitts and Nevis'">Saint Kitts and Nevis</smart-list-item>
    <smart-list-item [value]="'Saint Lucia'">Saint Lucia</smart-list-item>
    <smart-list-item [value]="'Saint Pierre and Miquelon'">Saint Pierre and Miquelon</smart-list-item>
    <smart-list-item [value]="'Saint Vincent and The Grenadines'">Saint Vincent and The Grenadines</smart-list-item>
    <smart-list-item [value]="'Samoa'">Samoa</smart-list-item>
    <smart-list-item [value]="'San Marino'">San Marino</smart-list-item>
    <smart-list-item [value]="'Sao Tome and Principe'">Sao Tome and Principe</smart-list-item>
    <smart-list-item [value]="'Saudi Arabia'">Saudi Arabia</smart-list-item>
    <smart-list-item [value]="'Senegal'">Senegal</smart-list-item>
    <smart-list-item [value]="'Serbia and Montenegro'">Serbia and Montenegro</smart-list-item>
    <smart-list-item [value]="'Seychelles'">Seychelles</smart-list-item>
    <smart-list-item [value]="'Sierra Leone'">Sierra Leone</smart-list-item>
    <smart-list-item [value]="'Singapore'">Singapore</smart-list-item>
    <smart-list-item [value]="'Slovakia'">Slovakia</smart-list-item>
    <smart-list-item [value]="'Slovenia'">Slovenia</smart-list-item>
    <smart-list-item [value]="'Solomon Islands'">Solomon Islands</smart-list-item>
    <smart-list-item [value]="'Somalia'">Somalia</smart-list-item>
    <smart-list-item [value]="'South Africa'">South Africa</smart-list-item>
    <smart-list-item [value]="'South Georgia and The South Sandwich Islands'">South Georgia</smart-list-item>
    <smart-list-item [value]="'Spain'">Spain</smart-list-item>
    <smart-list-item [value]="'Sri Lanka'">Sri Lanka</smart-list-item>
    <smart-list-item [value]="'Sudan'">Sudan</smart-list-item>
    <smart-list-item [value]="'Suriname'">Suriname</smart-list-item>
    <smart-list-item [value]="'Svalbard and Jan Mayen'">Svalbard and Jan Mayen</smart-list-item>
    <smart-list-item [value]="'Swaziland'">Swaziland</smart-list-item>
    <smart-list-item [value]="'Sweden'">Sweden</smart-list-item>
    <smart-list-item [value]="'Switzerland'">Switzerland</smart-list-item>
    <smart-list-item [value]="'Syrian Arab Republic'">Syrian Arab Republic</smart-list-item>
    <smart-list-item [value]="'Taiwan, Province of China'">Taiwan, Province of China</smart-list-item>
    <smart-list-item [value]="'Tajikistan'">Tajikistan</smart-list-item>
    <smart-list-item [value]="'Tanzania, United Republic of'">Tanzania, United Republic of</smart-list-item>
    <smart-list-item [value]="'Thailand'">Thailand</smart-list-item>
    <smart-list-item [value]="'Timor-leste'">Timor-leste</smart-list-item>
    <smart-list-item [value]="'Togo'">Togo</smart-list-item>
    <smart-list-item [value]="'Tokelau'">Tokelau</smart-list-item>
    <smart-list-item [value]="'Tonga'">Tonga</smart-list-item>
    <smart-list-item [value]="'Trinidad and Tobago'">Trinidad and Tobago</smart-list-item>
    <smart-list-item [value]="'Tunisia'">Tunisia</smart-list-item>
    <smart-list-item [value]="'Turkey'">Turkey</smart-list-item>
    <smart-list-item [value]="'Turkmenistan'">Turkmenistan</smart-list-item>
    <smart-list-item [value]="'Turks and Caicos Islands'">Turks and Caicos Islands</smart-list-item>
    <smart-list-item [value]="'Tuvalu'">Tuvalu</smart-list-item>
    <smart-list-item [value]="'Uganda'">Uganda</smart-list-item>
    <smart-list-item [value]="'Ukraine'">Ukraine</smart-list-item>
    <smart-list-item [value]="'United Arab Emirates'">United Arab Emirates</smart-list-item>
    <smart-list-item [value]="'United Kingdom'">United Kingdom</smart-list-item>
    <smart-list-item [value]="'United States'">United States</smart-list-item>
    <smart-list-item [value]="'United States Minor Outlying Islands'">United States Minor Outlying Islands
    </smart-list-item>
    <smart-list-item [value]="'Uruguay'">Uruguay</smart-list-item>
    <smart-list-item [value]="'Uzbekistan'">Uzbekistan</smart-list-item>
    <smart-list-item [value]="'Vanuatu'">Vanuatu</smart-list-item>
    <smart-list-item [value]="'Venezuela'">Venezuela</smart-list-item>
    <smart-list-item [value]="'Viet Nam'">Viet Nam</smart-list-item>
    <smart-list-item [value]="'Virgin Islands, British'">Virgin Islands, British</smart-list-item>
    <smart-list-item [value]="'Virgin Islands, U.S.'">Virgin Islands, U.S.</smart-list-item>
    <smart-list-item [value]="'Wallis and Futuna'">Wallis and Futuna</smart-list-item>
    <smart-list-item [value]="'Western Sahara'">Western Sahara</smart-list-item>
    <smart-list-item [value]="'Yemen'">Yemen</smart-list-item>
    <smart-list-item [value]="'Zambia'">Zambia</smart-list-item>
    <smart-list-item [value]="'Zimbabwe'">Zimbabwe</smart-list-item>
</smart-list-box>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put ListBoxModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put ListBoxModule from smart-webcomponents-angular/listbox on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { ListBoxModule } from 'smart-webcomponents-angular/listbox';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, ListBoxModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The ListBox component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.